# cheat_gui.cpp File Reference

GUI related to cheating. More...

`#include "stdafx.h"`
`#include "command_func.h"`
`#include "cheat_type.h"`
`#include "company_base.h"`
`#include "company_func.h"`
`#include "gfx_func.h"`
`#include "date_func.h"`
`#include "saveload/saveload.h"`
`#include "window_gui.h"`
`#include "newgrf.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "rail_gui.h"`
`#include "gui.h"`
`#include "company_gui.h"`
`#include "gamelog.h"`
`#include "table/strings.h"`
`#include "table/sprites.h"`

Go to the source code of this file.

## Data Structures
struct | CheatEntry
struct | CheatWindow
## Typedefs
typedef int32 | CheckButtonClick (int32, int32)
## Enumerations
enum | CheatWidgets { CW_PANEL }
## Functions
static int32 | ClickMoneyCheat (int32 p1, int32 p2)
static int32 | ClickChangeCompanyCheat (int32 p1, int32 p2)
static int32 | ClickSetProdCheat (int32 p1, int32 p2)
static int32 | ClickChangeClimateCheat (int32 p1, int32 p2)
void | EnginesMonthlyLoop ()
static int32 | ClickChangeDateCheat (int32 p1, int32 p2)
void | ShowCheatWindow ()
## Variables
static int32 | _money_cheat_amount = 10000000
| The 'amount' to cheat with.
static const CheatEntry | _cheats_ui []
static const NWidgetPart | _nested_cheat_widgets []
static const WindowDesc | _cheats_desc (WDP_AUTO, 0, 0, WC_CHEATS, WC_NONE, WDF_UNCLICK_BUTTONS, _nested_cheat_widgets, lengthof(_nested_cheat_widgets))

## Detailed Description

GUI related to cheating.

Definition in file cheat_gui.cpp.

## Function Documentation

static int32 ClickChangeClimateCheat | ( | int32 | p1,
|  | int32 | p2 |
| ) |  |  | `[static]`

Parameters:

  | p1 | new climate
  | p2 | unused

Definition at line 77 of file cheat_gui.cpp.

References _settings_game, GameSettings::game_creation, GamelogStartAction(), GamelogStopAction(), GamelogTestMode(), GLAT_CHEAT, GameCreationSettings::landscape, and ReloadNewGRFData().

static int32 ClickChangeCompanyCheat | ( | int32 | p1,
|  | int32 | p2 |
| ) |  |  | `[static]`

Parameters:

  | p1 | company to set to
  | p2 | is -1 or +1 (down/up)

Definition at line 50 of file cheat_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::GetPoolSize(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), and SetLocalCompany().

static int32 ClickChangeDateCheat | ( | int32 | p1,
|  | int32 | p2 |
| ) |  |  | `[static]`

Parameters:

  | p1 | unused
  | p2 | 1 (increase) or -1 (decrease)

Definition at line 97 of file cheat_gui.cpp.

References _cur_year, _date, ConvertDateToYMD(), ConvertYMDToDate(), YearMonthDay::day, InvalidateWindowClassesData(), MAX_YEAR, MIN_YEAR, YearMonthDay::month, ResetSignalVariant(), SetWindowDirty(), and YearMonthDay::year.

static int32 ClickSetProdCheat | ( | int32 | p1,
|  | int32 | p2 |
| ) |  |  | `[static]`

Parameters:

  | p1 | new value
  | p2 | unused

Definition at line 67 of file cheat_gui.cpp.

References SetWindowClassesDirty().

## Variable Documentation

const CheatEntry _cheats_ui[]`[static]`

Initial value:

     {
      {SLE_INT32, STR_CHEAT_MONEY,           &_money_cheat_amount,                    &_cheats.money.been_used,            &ClickMoneyCheat         },
      {SLE_UINT8, STR_CHEAT_CHANGE_COMPANY,  &_local_company,                         &_cheats.switch_company.been_used,   &ClickChangeCompanyCheat },
      {SLE_BOOL,  STR_CHEAT_EXTRA_DYNAMITE,  &_cheats.magic_bulldozer.value,          &_cheats.magic_bulldozer.been_used,  NULL                     },
      {SLE_BOOL,  STR_CHEAT_CROSSINGTUNNELS, &_cheats.crossing_tunnels.value,         &_cheats.crossing_tunnels.been_used, NULL                     },
      {SLE_BOOL,  STR_CHEAT_BUILD_IN_PAUSE,  &_cheats.build_in_pause.value,           &_cheats.build_in_pause.been_used,   NULL                     },
      {SLE_BOOL,  STR_CHEAT_NO_JETCRASH,     &_cheats.no_jetcrash.value,              &_cheats.no_jetcrash.been_used,      NULL                     },
      {SLE_BOOL,  STR_CHEAT_SETUP_PROD,      &_cheats.setup_prod.value,               &_cheats.setup_prod.been_used,       &ClickSetProdCheat       },
      {SLE_UINT8, STR_CHEAT_SWITCH_CLIMATE,  &_settings_game.game_creation.landscape, &_cheats.switch_climate.been_used,   &ClickChangeClimateCheat },
      {SLE_INT32, STR_CHEAT_CHANGE_DATE,     &_cur_year,                              &_cheats.change_date.been_used,      &ClickChangeDateCheat    },
    }

Definition at line 122 of file cheat_gui.cpp.

int32 _money_cheat_amount = 10000000`[static]`

The 'amount' to cheat with.

This variable is semantically a constant value, but because the cheat code requires to be able to write to the variable it is not constified.

Definition at line 38 of file cheat_gui.cpp.

const NWidgetPart _nested_cheat_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_GREY),
        NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_CHEATS, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
        NWidget(WWT_SHADEBOX, COLOUR_GREY),
        NWidget(WWT_STICKYBOX, COLOUR_GREY),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_GREY, CW_PANEL), SetDataTip(0x0, STR_CHEATS_TOOLTIP), EndContainer(),
    }

Definition at line 139 of file cheat_gui.cpp.